=== debian/changelog ===
iddawc (0.9.6-2) unstable; urgency=medium

  * New upload to increase urgency to medium

 -- Nicolas Mora <babelouest@debian.org>  Mon, 20 Jul 2020 07:02:43 -0400

iddawc (0.9.6-1) unstable; urgency=low

  * New upstream release
  * d/rules: avoid downloading dependencies if not found
  * d/rules: display ctest error on failure
  * d/control: Remove dh-exec from builddep

 -- Nicolas Mora <babelouest@debian.org>  Sun, 19 Jul 2020 08:24:55 -0400

iddawc (0.9.5-2) unstable; urgency=low

  * Upload to unstable
  * Set upstream metadata fields
  * Fix aotopkgtest

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 29 Jun 2020 07:04:27 -0400

iddawc (0.9.5-1) experimental; urgency=low

  * Initial release. Closes: #962279

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 03 Jun 2020 13:37:03 -0400
