## iddawc 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,11 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
 set(LIBRARY_VERSION_MAJOR "0")
 set(LIBRARY_VERSION_MINOR "9")
-set(LIBRARY_VERSION_PATCH "6")
+set(LIBRARY_VERSION_PATCH "8")
 set(ORCANIA_VERSION_REQUIRED "2.1.1")
-set(YDER_VERSION_REQUIRED "1.4.11")
-set(ULFIUS_VERSION_REQUIRED "2.6.8")
-set(RHONABWY_VERSION_REQUIRED "0.9.12")
+set(YDER_VERSION_REQUIRED "1.4.12")
+set(ULFIUS_VERSION_REQUIRED "2.7.1")
+set(RHONABWY_VERSION_REQUIRED "0.9.13")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -116,7 +116,6 @@
         PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
         VERSION "${LIBRARY_VERSION}"
         SOVERSION "${LIBRARY_SOVERSION}")
-target_link_libraries(iddawc ${LIBS})
 
 include(FindJansson)
 set(JANSSON_MIN_VERSION 2.11)
@@ -139,6 +138,7 @@
 	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
 	include_directories(${NETTLE_INCLUDE_DIRS})
 endif ()
+target_link_libraries(iddawc ${LIBS})
 
 include(FindMHD)
 find_package(MHD REQUIRED)
@@ -303,6 +303,10 @@
             introspection
             revocation
             registration
+            dpop
+            api_request
+            device
+            par
             )
 
         configure_file(
@@ -339,4 +343,3 @@
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
             PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 else ()
-    install(TARGETS ${TARGETS}
