=== debian/changelog ===
iddawc (0.9.8-2) unstable; urgency=medium

  * Remove d/patches
  * restore d/tests removed by mistake

 -- Nicolas Mora <babelouest@debian.org>  Sun, 10 Jan 2021 17:35:06 -0500

iddawc (0.9.8-1) unstable; urgency=medium

  * New upstream release (Closes: #979402)
  * d/symbols: update symbols list
  * d/tests: add new tests

 -- Nicolas Mora <babelouest@debian.org>  Sat, 09 Jan 2021 13:50:55 -0500

iddawc (0.9.7-1) unstable; urgency=medium

  * d/symbols: update symbols
  * d/control: Update standards version to 4.5.1 (no change)
  * d/control: add libiddawc-dev dependendies

 -- Nicolas Mora <babelouest@debian.org>  Fri, 18 Dec 2020 07:20:44 -0500
