=== debian/control ===
--- 
+++ 
@@ -9,12 +9,13 @@
              , libulfius-dev
              , librhonabwy-dev
              , libgnutls28-dev
+             , libjansson-dev
              , zlib1g-dev
              , cmake
              , pkg-config
              , check
              , doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/babelouest/iddawc
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
@@ -38,6 +39,13 @@
 Architecture: any
 Multi-Arch: same
 Depends: libiddawc0.9 (= ${binary:Version}), ${misc:Depends}
+       , liborcania-dev
+       , libyder-dev
+       , libulfius-dev
+       , librhonabwy-dev
+       , libgnutls28-dev
+       , libjansson-dev
+       , zlib1g-dev
 Description: OAuth2 and OIDC client library - development
  Handles the OAuth2 and OpenID Connect authentication process flow from the
  client side.
