=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, libgnutls28-dev, libjansson-dev, libyder-dev, librhonabwy-dev, liborcania-dev, libulfius-dev, check, libsubunit-dev, pkg-config
