## iddawc 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # CMake file used to build all programs
 #
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
-# Copyright 2019-20 Nicolas Mora <mail@babelouest.org>
+# Copyright 2019-2021 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License
@@ -25,16 +25,16 @@
 
 # library info
 
-set(PROJECT_DESCRIPTION "Handle the flow of OAuth2 and OpenID Connect authentication process from the client side")
+set(PROJECT_DESCRIPTION "OAuth2/OIDC client library")
 set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/iddawc/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
-set(LIBRARY_VERSION_MAJOR "0")
-set(LIBRARY_VERSION_MINOR "9")
-set(LIBRARY_VERSION_PATCH "8")
-set(ORCANIA_VERSION_REQUIRED "2.1.1")
-set(YDER_VERSION_REQUIRED "1.4.12")
-set(ULFIUS_VERSION_REQUIRED "2.7.1")
-set(RHONABWY_VERSION_REQUIRED "0.9.13")
+set(LIBRARY_VERSION_MAJOR "1")
+set(LIBRARY_VERSION_MINOR "1")
+set(LIBRARY_VERSION_PATCH "1")
+set(ORCANIA_VERSION_REQUIRED "2.2.1")
+set(YDER_VERSION_REQUIRED "1.4.14")
+set(ULFIUS_VERSION_REQUIRED "2.7.6")
+set(RHONABWY_VERSION_REQUIRED "1.1.2")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -64,6 +64,7 @@
 # cmake modules
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+set(IDWCC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/idwcc)
 
 include(GNUInstallDirs)
 include(CheckSymbolExists)
@@ -125,18 +126,18 @@
 	include_directories(${JANSSON_INCLUDE_DIRS})
 endif ()
 
+include(FindNettle)
+find_package(Nettle REQUIRED)
+if (NETTLE_FOUND)
+	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
+	include_directories(${NETTLE_INCLUDE_DIRS})
+endif ()
+
 include(FindGnuTLS)
 find_package(GnuTLS REQUIRED)
 if (GNUTLS_FOUND)
 	set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
 	include_directories(${GNUTLS_INCLUDE_DIRS})
-endif ()
-
-include(FindNettle)
-find_package(Nettle REQUIRED)
-if (NETTLE_FOUND)
-	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
-	include_directories(${NETTLE_INCLUDE_DIRS})
 endif ()
 target_link_libraries(iddawc ${LIBS})
 
@@ -166,6 +167,8 @@
         add_dependencies(iddawc orcania)
         set(ORCANIA_LIBRARIES orcania)
         include_directories(${orcania_BINARY_DIR})
+    else ()
+        include_directories(${ORCANIA_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${ORCANIA_LIBRARIES})
@@ -189,6 +192,8 @@
         add_dependencies(iddawc yder)
         set(YDER_LIBRARIES yder)
         include_directories(${yder_BINARY_DIR})
+    else ()
+        include_directories(${YDER_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${YDER_LIBRARIES})
@@ -214,6 +219,8 @@
         add_dependencies(iddawc ulfius)
         set(ULFIUS_LIBRARIES ulfius)
         include_directories(${ulfius_BINARY_DIR})
+    else ()
+        include_directories(${ULFIUS_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${ULFIUS_LIBRARIES})
@@ -241,10 +248,34 @@
         add_dependencies(iddawc rhonabwy)
         set(RHONABWY_LIBRARIES rhonabwy)
         include_directories(${rhonabwy_BINARY_DIR})
+    else ()
+        include_directories(${RHONABWY_INCLUDE_DIRS})
     endif ()
 endif ()
 target_link_libraries(iddawc ${RHONABWY_LIBRARIES})
 set(LIBS ${LIBS} ${RHONABWY_LIBRARIES})
+
+# build idwcc
+
+option(BUILD_IDWCC "Build idwcc application." ON)
+
+if (BUILD_IDWCC)
+    find_package(Threads REQUIRED)
+    set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
+    include(FindZLIB)
+    find_package(ZLIB REQUIRED)
+    if (ZLIB_FOUND)
+      set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
+      include_directories(${ZLIB_INCLUDE_DIRS})
+    endif ()
+    add_executable(idwcc ${IDWCC_DIR}/idwcc.c ${INC_DIR}/iddawc.h ${IDWCC_DIR}/http_compression_callback.c ${IDWCC_DIR}/http_compression_callback.h ${IDWCC_DIR}/static_compressed_inmemory_website_callback.c ${IDWCC_DIR}/static_compressed_inmemory_website_callback.h ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
+    set_target_properties(idwcc PROPERTIES SKIP_BUILD_RPATH TRUE)
+    add_dependencies(idwcc iddawc)
+    target_link_libraries(idwcc iddawc ${LIBS})
+    install(TARGETS idwcc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    install(FILES ${IDWCC_DIR}/idwcc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
+    install(DIRECTORY ${IDWCC_DIR}/webapp/ DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/idwcc/webapp/ COMPONENT runtime)
+endif ()
 
 # documentation
 
@@ -297,49 +328,3 @@
             implicit
             id_token
             token
-            load_config
-            load_userinfo
-            flow
-            introspection
-            revocation
-            registration
-            dpop
-            api_request
-            device
-            par
-            )
-
-        configure_file(
-                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
-                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
-                @ONLY)
-
-        foreach (t ${TESTS})
-            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
-            target_include_directories(${t} PUBLIC ${TST_DIR})
-            target_link_libraries(${t} PUBLIC ${LIBS})
-            add_test(NAME ${t}
-                    WORKING_DIRECTORY ${TST_DIR}
-                    COMMAND ${t})
-        endforeach ()
-    endif ()
-endif ()
-
-# install target
-
-option(INSTALL_HEADER "Install the header files" ON) # Install iddawc.h or not
-
-configure_file(libiddawc.pc.in libiddawc.pc @ONLY)
-
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libiddawc.pc
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
-
-set(TARGETS iddawc)
-
-if (INSTALL_HEADER)
-    install(TARGETS ${TARGETS}
-            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-else ()
