=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build the software
 #
-# Copyright 2019-2020 Nicolas Mora <mail@babelouest.org>
+# Copyright 2019-2021 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -19,7 +19,7 @@
 # License along with this library.	If not, see <http://www.gnu.org/licenses/>.
 #
 PROJECT_NAME=iddawc
-PROJECT_DESCRIPTION=OAuth2 client library
+PROJECT_DESCRIPTION=OAuth2-OIDC client library
 PROJECT_BUGREPORT_PATH=https://github.com/babelouest/iddawc/issues
 PKGCONF_REQ=
 PKGCONF_REQ_PRIVATE=
@@ -35,9 +35,9 @@
 SONAME=-soname
 OBJECTS=iddawc.o
 OUTPUT=libiddawc.so
-VERSION_MAJOR=0
-VERSION_MINOR=9
-VERSION_PATCH=8
+VERSION_MAJOR=1
+VERSION_MINOR=1
+VERSION_PATCH=1
 
 .PHONY: all clean
