=== debian/changelog ===
iddawc (1.1.1-2) unstable; urgency=medium

  * d/patches add cmake patch to avoid downloading missing dependencies

 -- Nicolas Mora <babelouest@debian.org>  Sat, 20 Nov 2021 15:37:33 -0500

iddawc (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * d/patches: remove uninit.patch

 -- Nicolas Mora <babelouest@debian.org>  Thu, 18 Nov 2021 22:51:31 -0500

iddawc (1.1.0-2) unstable; urgency=medium

  * d/patches: disable test_iddawc_code_pkce_flow
  * d/control: update idwcc description (Closes: #999801)

 -- Nicolas Mora <babelouest@debian.org>  Tue, 16 Nov 2021 19:44:37 -0500

iddawc (1.1.0-1) unstable; urgency=medium

  * New upstream release
  * d/control: new package name
  * d/control: Upgrade Standards-Version to 4.6.0 (No change)
  * d/patch: Add ununit.patch
  * d/symbols: Update symbols table
  * d/salsa-ci.yml: enable salsa CI

 -- Nicolas Mora <babelouest@debian.org>  Tue, 16 Nov 2021 08:15:27 -0500
