=== debian/control ===
--- 
+++ 
@@ -15,17 +15,20 @@
              , pkg-config
              , check
              , doxygen
-Standards-Version: 4.5.1
+             , gnutls-bin
+Standards-Version: 4.6.0
 Homepage: https://github.com/babelouest/iddawc
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
 Rules-Requires-Root: no
 
-Package: libiddawc0.9
+Package: libiddawc1.1
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: libiddawc0.9 (<< 0.9.8-2)
+Replaces: libiddawc0.9 (<< 0.9.8-2)
 Description: OAuth2 and OIDC client library
  Handles the OAuth2 and OpenID Connect authentication process flow from the
  client side.
@@ -38,7 +41,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libiddawc0.9 (= ${binary:Version}), ${misc:Depends}
+Depends: libiddawc1.1 (= ${binary:Version}), ${misc:Depends}
        , liborcania-dev
        , libyder-dev
        , libulfius-dev
@@ -55,3 +58,20 @@
   - Validates response values
  .
  This package contains the development files.
+
+Package: idwcc
+Architecture: any
+Depends: ${shlibs:Depends}
+       , ${misc:Depends}
+       , libiddawc1.1 (= ${binary:Version})
+       , fonts-fork-awesome
+       , libjs-jquery
+       , libjs-bootstrap4
+       , libjs-popper.js
+Description: Client for OAuth2/OIDC AS configuration validation
+ Provides a web application to be used as an OpenID Connect or OAuth2
+ client.
+ .
+ Supports PKCE, token introspection, revocation, client registration,
+ DPoP, Rich Authorization Request, Pushed Authorization Request,
+ JWT Access tokens, encrypted tokens, requests and responses.
