=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,7 @@
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
+	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
 	cd build && $(MAKE) test -j1
 endif
