=== debian/watch ===
version=4

# https://github.com/babelouest/iddawc
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%iddawc-$1.tar.gz%" \
   https://github.com/babelouest/iddawc/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
